import React from 'react';
import { RouterInstance, IRouterTemplates } from 'router-primitives';
import { AnimationBinding, When } from '../src_animated_components';
interface DefaultProps<R> {
    children?: <P, T extends string>(router: R) => React.ReactElement<P, T> | null;
    uncontrolled?: boolean;
}
interface LinkProps {
    action: 'show' | 'hide';
    simulated?: boolean;
    data?: any;
    pathData?: Record<string, any>;
    replaceLocation?: boolean;
    disableCaching?: boolean;
    addCacheToLocation?: boolean;
    children?: React.ReactNode;
}
interface RouterAnimateProps {
    when?: When;
    children?: React.ReactElement;
    unMountOnHide?: boolean;
    unMountOnShow?: boolean;
    id?: string;
    animationBinding?: AnimationBinding;
    enterAfterParentStart?: boolean;
    enterAfterParentFinish?: boolean;
    exitAfterChildStart?: string[];
    exitAfterChildFinish?: string[];
}
declare type RouterT<R> = React.FC<DefaultProps<R>> & {
    Link: React.FC<LinkProps>;
    Animate: React.FC<RouterAnimateProps>;
};
export declare const createRouterComponents: <CustomTemplates extends IRouterTemplates<undefined, null>>(routers: Record<string, RouterInstance<CustomTemplates, import("router-primitives").NarrowRouterTypeName<keyof import("router-primitives").AllTemplates<CustomTemplates>>>>) => Record<string, RouterT<RouterInstance<CustomTemplates, import("router-primitives").NarrowRouterTypeName<keyof import("router-primitives").AllTemplates<CustomTemplates>>>>>;
export {};
